#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
	Copyright zmofun@163.com           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2022.1.29    移植到PYTHON TKINTER版本之后，
  2022.2.1~2.3    移植到PyQt5版本
  2022.10.23 18:00~22:00   移植到PYTHON PyGame版本
  2022.10.24 键不松开，加速
'''

import pygame
from game_box_PyGame import *

class Game:
    def __init__(self):
        #keya = [87, 83, 65, 68]  # 上下左右w, s, a, d
        #keyb = [38, 40, 37, 39]  # 上下左右up, down, left, right
        self.keya = [pygame.K_w, pygame.K_s, pygame.K_a, pygame.K_d]  # 上下左右w, s, a, d
        self.keyb = [pygame.K_UP, pygame.K_DOWN, pygame.K_LEFT, pygame.K_RIGHT]  # 上下左右up, down, left, right
        pygame.init()
        pygame.key.set_repeat(500,50) #当开启重复响应按键，那么用户持续按下某一按键，就会不断产生同一 pygame.KEYDOWN 事件。
        pygame.font.init()
        self.width = 640
        self.height = 480
        self.canvas = pygame.display.set_mode((self.width, self.height))
        self.canvas.fill((0,0,255))
        pygame.display.set_caption('ERAS')

        self.clock = pygame.time.Clock()
        self.box = [GameBox(self.canvas), GameBox(self.canvas)]
        self.box[0].init(105, 50, 13, 16, 30, 40, self.keya,self.clock)
        self.box[1].init(322, 50, 13, 16, 30, 560, self.keyb,self.clock)

        self.count=0

    def game_loop(self,key):
        self.box[0].play(key)
        self.box[1].play(key)


    def run(self):
        self.run=True
        pygame.event.clear()

        while self.run:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.run = False
                if event.type == pygame.KEYDOWN:
                    if(event.key ==pygame.K_ESCAPE):
                        pygame.quit()
                        return 0
                    self.game_loop(event.key)

            self.game_loop(1)

            pygame.display.update()
            self.clock.tick(60)  # 避免CPU占用率过高 指定循环频率，每秒循环60次
            pygame.time.wait(50)
        pygame.quit()

if __name__ == '__main__':
    mygame = Game()
    mygame.run()
