#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
	Copyright zmofun@163.com           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2022.1.29    移植到PYTHON TKINTER版本之后，
  2022.2.1~2.3    移植到PyQt5版本
  2022.10.23 18:00~22:00   移植到PYTHON PyGame版本
  2022.10.24 键不松开，加速
'''

import pygame
import random
class Shape:
    # shapeall[9][25]
    shapeall = [[
        0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0
    ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
                    0, 0, 1, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
                    0, 0, 0, 0, 0
                ]]

    def __init__(self, canvas, nextx, nexty):
        self.canvas = canvas
        self.nextx = nextx
        self.nexty = nexty

    def getnextsh(self, x, y, il, ic, level):
        no, i = 0, 0
        self.no = random.randint(0, 6 - 1) + level
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        for i in range(0, 25):
            self.s[i // 5][i % 5] = self.b[i // 5][i % 5]
            self.b[i // 5][i % 5] = Shape.shapeall[self.no][i]
        return 0

    def init(self, x, y, w, il, ic, level):
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        self.width = w
        self.s = [([0] * 5) for i in range(5)]
        self.b = [([0] * 5) for i in range(5)]
        self.t = [([0] * 5) for i in range(0, 5)]
        self.l, self.c = 0, 0
        self.srect = [([0] * 5) for i in range(5)]
        self.brect = [([0] * 5) for i in range(5)]
        self.trect = [([0] * 5) for i in range(5)]

        self.getnextsh(x, y, il, ic, level)

        return 0

    def rotate(self,canvas):
        self.erase(canvas)
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.s[i][j]

        for i in range(0, 5):
            for j in range(0, 5):
                self.s[i][j] = self.t[4 - j][i]
        self.paint(canvas)
        return 0

    def paint(self, canvas):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    pygame.draw.rect(canvas,(255,255,0),(self.px + j * (self.width // 5) + 1,
                                    self.py + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),1)

        return 0

    def paintnext(self, canvas, x, y):
        i, j = 0, 0
        pygame.draw.rect(canvas, (0, 0, 255), (x, y, self.width , self.width ), 0)
        for i in range(0, 5):
            for j in range(0, 5):
                if self.b[i][j]:
                    pygame.draw.rect(canvas,(255,255,0),(x + j * (self.width // 5) + 1,
                                    y + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),1)
        return 0

    def erase(self,canvas):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    pygame.draw.rect(canvas,(0,0,255),(self.px + j * (self.width // 5) + 1,
                                    self.py + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),0)
        return 0

    def move(self, canvas, direct):
        self.erase(canvas)
        if direct == 1:
            self.px = self.px - self.width // 5
            self.c = self.c - 1
        elif direct == 2:
            self.px = self.px + self.width // 5
            self.c = self.c + 1
        else:
            self.py = self.py + self.width // 5
            self.l = self.l + 1
        self.paint(canvas)
        return 0
