# -*- coding: UTF-8 -*-
'''
	Copyright zmofun           All rights reserved!
	http://www.zmofun.com
	2000.1.14        TurboC++2.0

  zmofun@163.com
  2022.10.23 18:00~22:00   移植到PYTHON PyGame版本
  2022.10.24 键不松开，加速
'''

import pygame
import random

class Shape:
    # shapeall[9][25]
    shapeall = [[
        0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0
    ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0,
                    0, 0, 1, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0,
                    0, 0, 0, 0, 0
                ],
                [
                    0, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0,
                    0, 0, 0, 0, 0
                ]]

    def __init__(self, canvas, nextx, nexty):
        self.canvas = canvas
        self.nextx = nextx
        self.nexty = nexty

    def getnextsh(self, x, y, il, ic, level):
        no, i = 0, 0
        self.no = random.randint(0, 6 - 1) + level
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        for i in range(0, 25):
            self.s[i // 5][i % 5] = self.b[i // 5][i % 5]
            self.b[i // 5][i % 5] = Shape.shapeall[self.no][i]
        return 0

    def init(self, x, y, w, il, ic, level):
        self.px = x
        self.py = y
        self.l = il
        self.c = ic
        self.width = w
        self.s = [([0] * 5) for i in range(5)]
        self.b = [([0] * 5) for i in range(5)]
        self.t = [([0] * 5) for i in range(0, 5)]
        self.l, self.c = 0, 0
        self.srect = [([0] * 5) for i in range(5)]
        self.brect = [([0] * 5) for i in range(5)]
        self.trect = [([0] * 5) for i in range(5)]

        self.getnextsh(x, y, il, ic, level)

        return 0

    def rotate(self,canvas):
        self.erase(canvas)
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.s[i][j]

        for i in range(0, 5):
            for j in range(0, 5):
                self.s[i][j] = self.t[4 - j][i]
        self.paint(canvas)
        return 0

    def paint(self, canvas):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    pygame.draw.rect(canvas,(255,255,0),(self.px + j * (self.width // 5) + 1,
                                    self.py + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),1)

        return 0

    def paintnext(self, canvas, x, y):
        i, j = 0, 0
        pygame.draw.rect(canvas, (0, 0, 255), (x, y, self.width , self.width ), 0)
        for i in range(0, 5):
            for j in range(0, 5):
                if self.b[i][j]:
                    pygame.draw.rect(canvas,(255,255,0),(x + j * (self.width // 5) + 1,
                                    y + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),1)
        return 0

    def erase(self,canvas):
        i, j = 0, 0
        for i in range(0, 5):
            for j in range(0, 5):
                if self.s[i][j]:
                    pygame.draw.rect(canvas,(0,0,255),(self.px + j * (self.width // 5) + 1,
                                    self.py + i * (self.width // 5) + 1,
                                    self.width // 5 - 2, self.width // 5 - 2),0)
        return 0

    def move(self, canvas, direct):
        self.erase(canvas)
        if direct == 1:
            self.px = self.px - self.width // 5
            self.c = self.c - 1
        elif direct == 2:
            self.px = self.px + self.width // 5
            self.c = self.c + 1
        else:
            self.py = self.py + self.width // 5
            self.l = self.l + 1
        self.paint(canvas)
        return 0


class GameBox:
    def __init__(self, canvas):
        self.canvas = canvas
        self.count=0

    def init(self, x, y, boxw, w, h, messx, keyin,clock):
        self.clock=clock
        self.stick = [([0] * 22) for i in range(41)]
        self.px = x
        self.py = y
        self.boxwidth = boxw
        self.boxperline = w
        self.boxpercolumn = h
        self.pxmess = messx
        self.level = 1
        self.levelmess = None
        self.score = 0
        self.scoremess = None
        self.speed = 1
        self.speedmess = None
        self.layer = 3
        self.layermess = None
        pygame.time.Clock().tick()  # 更新clock对象
        self.inter = pygame.time.get_ticks()  # 该时间指的从pygame初始化后开始计算，到调用该函数为止
        self.begin = 0
        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0
        for i in range(0, self.boxpercolumn):
            self.stick[i][0] = 1
            self.stick[i][self.boxperline + 1] = 1

        for j in range(0, self.boxperline + 2):
            self.stick[self.boxpercolumn][j] = 1

        #外框
        pygame.draw.rect(self.canvas,(255,255,0),
            (self.px - 1,
            self.py - 1,
            self.boxperline * self.boxwidth + 1,
            self.boxpercolumn * self.boxwidth + 1),1)
        self.initmessage()
        self.controlkey = keyin
        self.paint()
        self.curshape = Shape(self.canvas, self.pxmess - 15, self.py + 200)
        self.curshape.init(
            self.px + self.boxwidth * (self.boxperline // 2 - 2), self.py,
            5 * self.boxwidth, 0, self.boxperline // 2 - 2, self.level)


    def gamebegin(self):
        i, j, b = 0, 0, 0
        randnum = [
            1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0,
            1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1,
            0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0,
            1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1,
            0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1,
            0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 0, 1,
            0, 1, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0,
            0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0,
            1, 0
        ]

        for i in range(0, self.boxpercolumn - 1):  # clear game box's stick
            for j in range(1, self.boxperline + 1):
                self.stick[i][j] = 0

        for i in range(0, self.layer):
            for j in range(1, self.boxperline + 1):
                b = random.randint(0, 20 - 1) + i
                self.stick[self.boxpercolumn - 1 - i][j] = randnum[b + j]
                if self.stick[i][j]:
                    pygame.draw.rect(self.canvas,(255,255,0),(
                        self.px + self.boxwidth * (j - 1) + 1,
                        self.py + self.boxwidth * i + 1,
                        self.boxwidth * j - 1,
                        self.boxwidth * (i + 1) - 1),1)

        self.paintstick()
        self.curshape.getnextsh(
            self.px + self.boxwidth * (self.boxperline // 2 - 3), self.py, 0,
            self.boxperline // 2 - 2, self.level)
        self.curshape.paint(self.canvas)
        self.curshape.paintnext(self.canvas,self.pxmess - 15, self.py + 200)
        self.score = 0
        self.showscore()
        self.begin = 1
        return 0

    def gameconfiged(self, key):
        if not key:
            return 0
        if key == self.controlkey[0]:
            self.level = (self.level + 1) % 4
        if key == self.controlkey[1]:
            return 1
        if key == self.controlkey[2]:
            self.speed = (self.speed + 1) % 10
        if key == self.controlkey[3]:
            self.layer = (self.layer + 1) % 10
        self.showmessage()
        return 0

    def draw_text(self,px,py,text):
        font = pygame.font.SysFont('arial', 12, bold=True)
        label = font.render(text, 1, (255,255,0),(0,0,255))
        self.canvas.blit(label, (px, py))

    def initmessage(self):
        self.draw_text(self.px + 100,
                                460,
                                text="http://www.zmofun.com")
        self.draw_text(self.pxmess,
                                self.py + 20,
                                text="LEVEL")
        self.draw_text(self.pxmess,
                                self.py + 60,
                                text="SPEED")

        self.draw_text(self.pxmess,
                                self.py + 100,
                                text="LAYER")
        self.showscore()
        return 0

    def showmessage(self):
        mess = "%d" % self.level
        self.draw_text(self.pxmess + 20 + 6,
            self.py + 40 + 2,
            text=mess)
        mess = "%d" % self.speed
        self.draw_text(self.pxmess + 20 + 6,
            self.py + 80 + 2,
            text=mess)
        mess = "%d" % self.layer
        self.draw_text(self.pxmess + 20 + 6,
            self.py + 120 + 2,
            text=mess)
        self.showscore()

        return 0

    def showMe(self,m):
        self.draw_text(self.px + 50 + 6,
                       self.py - 20 + 2,
                       text=m)
        return 0

    def showscore(self):
        mess = "%d" % self.score
        self.draw_text(self.px + 50 + 6,
            self.py - 20 + 2,
            text=mess)
        return 0

    def addscore(self):
        i, j, line, ln, high, addspeed = 0, 0, 0, 0, 0, 0
        t = [0] * 40
        self.line = 0
        for i in range(self.boxpercolumn - 1, -1, -1):
            t[i] = 0
            for j in range(1, self.boxperline + 1):
                t[i] += self.stick[i][j]
            if t[i]:
                self.high = i
            if t[i] == self.boxperline:
                line = line + 1
                t[i] = 1
            else:
                t[i] = 0
        for i in range(self.boxpercolumn - 1, high - 1, -1):
            if t[i]:
                ln = i - 1
                while t[ln]:
                    ln = ln - 1
                for j in range(1, self.boxperline + 1):
                    self.stick[i][j] = self.stick[ln][j]
                    self.stick[ln][j] = 0
                t[ln] = 1
        self.paintstick()
        addspeed = self.score // 1000
        if line > 3:
            self.score += 2 * line * 100
        else:
            self.score += line * 100
        if addspeed != self.score // 1000:
            self.speed = (self.speed + 1) % 10
        self.showscore()

        return 0

    def paint(self):
        self.showmessage()
        return 0

    def paintstick(self):
        i, j = 0, 0
        pygame.draw.rect(self.canvas, (0, 0, 255),
                         (self.px,
                          self.py + self.boxwidth * i + 1,
                          self.boxwidth - 2,
                          self.boxwidth - 2), 1)
        for i in range(0, self.boxpercolumn):
            for j in range(1, self.boxperline + 1):
                if self.stick[i][j]:
                    pygame.draw.rect(self.canvas,(255,255,0),
                        (self.px + self.boxwidth * (j - 1) + 1,
                        self.py + self.boxwidth * i + 1,
                        self.boxwidth - 2,
                        self.boxwidth - 2),1)
                else:
                    pygame.draw.rect(self.canvas, (0, 0, 255),
                                     (self.px + self.boxwidth * (j - 1) + 1,
                                      self.py + self.boxwidth * i + 1,
                                      self.boxwidth - 2,
                                      self.boxwidth - 2), 0)
        return 0

    def gameover(self):
        i, j = 0, 0
        if self.curshape.l < 1:
            return 1
        else:
            for i in range(0, 5):
                for j in range(0, 5):
                    if self.curshape.s[i][j]:
                        self.stick[i +
                                   self.curshape.l][self.curshape.c +
                                                    j] = self.curshape.s[i][j]
        self.addscore()
        return 0

    def canmove(self, direct):
        i, j = 0, 0
        if direct == 1:
            for j in range(0, 5):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c - 1 + j]:
                        return 0
        elif direct == 2:
            for j in range(4, -1, -1):
                for i in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + i][self.curshape.c + 1 + j]:
                        return 0
        elif direct == 3:
            for i in range(4, -1, -1):
                for j in range(0, 5):
                    if self.curshape.s[i][j] and self.stick[
                            self.curshape.l + 1 + i][self.curshape.c + j]:
                        return 0
        return 1

    def canrotate(self):
        i, j = 0, 0
        self.t = [([0] * 5) for i in range(0, 5)]
        for i in range(0, 5):
            for j in range(0, 5):
                self.t[i][j] = self.curshape.s[4 - j][i]
                if self.t[i][j] and self.stick[self.curshape.l +
                                               i][self.curshape.c + j]:
                    return 0
        return 1

    def play(self, key):
        if not self.begin:
            if self.gameconfiged(key):
                self.gamebegin()
            return 0

        if key == self.controlkey[0]:
            if self.canrotate():
                self.curshape.rotate(self.canvas)
        if key == self.controlkey[2]:
            if self.canmove(1):
                self.curshape.move(self.canvas, 1)
        if key == self.controlkey[3]:
            if self.canmove(2):
                self.curshape.move(self.canvas, 2)
        if key == self.controlkey[1]:
            if self.canmove(3):
                self.curshape.move(self.canvas, 3)


        #self.clock.tick()  #更新clock对象
        now = pygame.time.get_ticks()   #该时间指的从pygame初始化后开始计算，到调用该函数为止
        #self.showMe(str(now - self.inter))

        #self.showMe(str(self.count))

        if (now - self.inter) > (2000 - 100 * self.level -
                                               100 * self.speed):

            if self.canmove(3):
                #self.clock.tick()  # 更新clock对象
                self.inter = pygame.time.get_ticks()
                self.curshape.move(self.canvas,3)
            else:
                if self.gameover():
                    self.begin = 0
                else:
                    self.curshape.getnextsh(
                        self.px + self.boxwidth * (self.boxperline // 2 - 3),
                        self.py, 0, self.boxperline // 2 - 2, self.level)
                    self.curshape.paintnext(self.canvas,self.pxmess - 10, self.py + 200)
        return 0

class Game:
    def __init__(self):
        #keya = [87, 83, 65, 68]  # 上下左右w, s, a, d
        #keyb = [38, 40, 37, 39]  # 上下左右up, down, left, right
        self.keya = [pygame.K_w, pygame.K_s, pygame.K_a, pygame.K_d]  # 上下左右w, s, a, d
        self.keyb = [pygame.K_UP, pygame.K_DOWN, pygame.K_LEFT, pygame.K_RIGHT]  # 上下左右up, down, left, right
        pygame.init()
        pygame.key.set_repeat(500,50) #当开启重复响应按键，那么用户持续按下某一按键，就会不断产生同一 pygame.KEYDOWN 事件。
        pygame.font.init()
        self.width = 640
        self.height = 480
        self.canvas = pygame.display.set_mode((self.width, self.height))
        self.canvas.fill((0,0,255))
        pygame.display.set_caption('ERAS')

        self.clock = pygame.time.Clock()
        self.box = [GameBox(self.canvas), GameBox(self.canvas)]
        self.box[0].init(105, 50, 13, 16, 30, 40, self.keya,self.clock)
        self.box[1].init(322, 50, 13, 16, 30, 560, self.keyb,self.clock)

        self.count=0

    def game_loop(self,key):
        self.box[0].play(key)
        self.box[1].play(key)


    def run(self):
        self.run=True
        pygame.event.clear()

        while self.run:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.run = False
                if event.type == pygame.KEYDOWN:
                    if(event.key ==pygame.K_ESCAPE):
                        pygame.quit()
                        return 0
                    self.game_loop(event.key)

            self.game_loop(1)

            pygame.display.update()
            self.clock.tick(60)  # 避免CPU占用率过高 指定循环频率，每秒循环60次
            pygame.time.wait(50)
        pygame.quit()

mygame = Game()
mygame.run()



